#include <iostream>
#include <string>
#include <vector>

using namespace std;

void readframe(vector<string> &v, int h) {
	for (int i=0; i<h; ++i) {
		v.push_back(string());
		cin >> v.back();
	}
}


void evaluate(vector<string> &f0, vector<string> &f1, char ch) {
	int minx1=1666, miny1=1666, maxx1=-666, maxy1=-666;
	int minx2=1666, miny2=1666, maxx2=-666, maxy2=-666;
	vector<string> blank;
	vector<string>::iterator j=f1.begin();
	for (vector<string>::iterator i=f0.begin(); i!= f0.end(); ++i, ++j) {

		//cout << *j << endl;
		int y = blank.size();
		blank.push_back(string());
		blank.back().reserve(i->size());
		for (int x=0; x<(int)i->size(); ++x) {
			if ((*i)[x]==ch) {
				if (x < minx1) minx1 = x;
				if (x > maxx1) maxx1 = x;
				if (y < miny1) miny1 = y;
				if (y > maxy1) maxy1 = y;

				blank.back().push_back((*j)[x]);
			} else {
				blank.back().push_back((*i)[x]);
			}
			if ((*j)[x]==ch) {
				if (x < minx2) minx2 = x;
				if (x > maxx2) maxx2 = x;
				if (y < miny2) miny2 = y;
				if (y > maxy2) maxy2 = y;
			}
		}
	}
	//cout << endl;
	//cout << minx1 << " " << miny1 << " " << maxx1 << " " << maxy1<<endl;
	//cout << minx2 << " " << miny2 << " " << maxx2 << " " << maxy2<<endl;
	//cout << endl;
	//for (vector<string>::iterator i=blank.begin(); i!= blank.end(); ++i)
	//	cout << *i << endl;
	//cout << endl;
	int dx = minx2 - minx1;
	int dy = miny2 - miny1;
	//cout << dx << " " << dy << endl;
	for (int y=miny1; y<=maxy1; ++y) {
		int ry = miny2 + dy + y-miny1;
		if (ry < 0 || ry >= (int)blank.size())
			continue;
		for (int x=minx1; x<=maxx1; ++x) {
			int rx = minx2 + dx + x-minx1;
			if (rx < 0 || rx >= (int)blank[ry].size())
					continue;
			if (f0[y][x] == ch) {
				blank[ry][rx] = ch;
			}
		}
	}
	for (vector<string>::iterator i=blank.begin(); i!= blank.end(); ++i)
		cout << *i << endl;
	cout << endl;
}

int main() {
	int h, w;
	std::string ch;

	while (cin >> h >> w >> ch) {
		if (h+w == 0) {
			break;
		}
		vector<string> f0, f1;
		readframe(f0,h);
		readframe(f1,h);
		evaluate(f0, f1, ch[1]);
	}

	return 0;
}
